package com.testService;

import com.LocalService.R;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.os.Messenger;
import android.os.RemoteException;
import android.widget.TextView;
import android.widget.Toast;

public class MessengerActivity extends Activity {
	/** Called when the activity is first created. */
	private Messenger mService = null;

	private boolean mIsBound;

	private TextView mCallbackText;

	// עָMessage's replyTo ֵֶclient Messenger
	static final int MSG_REGISTER_CLIENT = 1;
	// ȡָMessage's replyTo ֵֶǰoMSG_REGISTER_CLIENTMessenger
	static final int MSG_UNREGISTER_CLIENT = 2;
	// ָڿͻ˺ͷֱӽ
	static final int MSG_SET_VALUE = 3;

	class IncomingHandler extends Handler {

		@Override
		public void handleMessage(Message msg) {
			switch (msg.what) {
			case MSG_SET_VALUE:
				mCallbackText.setText("Received from service: " + msg.arg1);
				break;
			default:
				super.handleMessage(msg);
			}
		}
	}

	final Messenger mMessenger = new Messenger(new IncomingHandler());

	private ServiceConnection mConnection = new ServiceConnection() {

		@Override
		public void onServiceDisconnected(ComponentName name) {
			// ̱ʱãΪͬһǱԶᷢ
			// ʱҲ
			mService = null;
			mCallbackText.setText("Disconnected.");

			Toast.makeText(MessengerActivity.this,
					R.string.remote_service_disconnected, Toast.LENGTH_SHORT)
					.show();

		}

		@Override
		public void onServiceConnected(ComponentName name, IBinder service) {
			// serviceӽʱø÷
			// IBinderӿԱǿԸservice
			// ǿͨIDLӿ
			mService = new Messenger(service);
			mCallbackText.setText("Attached.");

			// ֻŶŷ
			try {
				// ע
				Message msg = Message.obtain(null, MSG_REGISTER_CLIENT);
				msg.replyTo = mMessenger;
				mService.send(msg);

				// 
				msg = Message.obtain(null, MSG_SET_VALUE, 22222222, 0);
				mService.send(msg);
			} catch (RemoteException e) {
				// In this case the service has crashed before we could even
				// do anything with it; we can count on soon being
				// disconnected (and then reconnected if it can be restarted)
				// so there is no need to do anything here.
			}
			Toast.makeText(MessengerActivity.this,
					R.string.remote_service_connected, Toast.LENGTH_SHORT)
					.show();
		}
	};

	void doBindService() {
		// bindService(new Intent("com.LocalService.LocalService"), mConnection,
		// Context.BIND_AUTO_CREATE);
		bindService(new Intent("com.LocalService.MessengerService"),
				mConnection, Context.BIND_AUTO_CREATE);
		mIsBound = true;
		mCallbackText.setText("Binding.");

	}

	void doUnbindService() {
		if (mIsBound) {
			if (mService != null) {
				try {
					// ȡע
					Message msg = Message.obtain(null, MSG_UNREGISTER_CLIENT);
					msg.replyTo = mMessenger;
					mService.send(msg);
				} catch (RemoteException e) {
					// There is nothing special we need to do if the service
					// has crashed.
				}
			}

			// Detach our existing connection.
			unbindService(mConnection);
			mIsBound = false;
			mCallbackText.setText("Unbinding.");

		}
	}

	@Override
	protected void onDestroy() {
		doUnbindService();
		super.onDestroy();
	}

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.messenger);
		mCallbackText = (TextView) findViewById(R.id.text);
		doBindService();
	}
}